/*All ADuC706x library code provided by ADI, including this file, is provided
	as is without warranty of any kind, either expressed or implied.
 	You assume any and all risk from the use of this code.  It is the
 	responsibility of the person integrating this code into an application
 	to ensure that the resulting application performs as required and is safe.

Status:			Alpha tested.
Incomplete:		All.
Tools:			Developed using Keil uV3 version 3.53.
Hardware:		ADuC7060.
Description:	Example C functions to illustrate external modules.
Responsibility:
	Group:		IAC Software.
	Person:		Eckart Hartmann.
Modifications:
	2008/02/21	Design Start.
*/
#include	"ioADuC7060.h"
#include	"math.h"
#include	"stdio.h"
#include	"..\LibIar\Adc\LibADC706x.h"
#include	"..\LibIar\Dac\LibDAC706x.h"
#include	"..\LibIar\Urt\LibUrt706x.h"
#include    "..\LibIar\T\LibTim706x.h"
#include    "..\LibIar\Fee\LibFee706x.h"
#include    "..\LibIar\Clk\LibClk706x.h"

/*TSet sets up the timers to various modes.	*/
void TSet(void)
	{
	TCfg(0,T_D256,T_32K,1);
	TCfg(1,T_D1,T_32K,1);
	TCfg(2,T_D1,T_32K,1);
	TCfg(3,T_D1,T_32K,1);

	TMod(0,T_UP,T_BIN);
	TCap(0,IUART);
	TGo(0,0x100000,T_RUN);
	TMod(1,T_DOWN,T_BIN);
	TGo(1,0x010000,T_RUN);
	TMod(2,T_DOWN,T_BIN);
	TGo(2,0x002000,T_RUN);
	TMod(3,T_DOWN,T_BIN);
	TGo(3,0x003000,T_RUN);
	}	

/*FeeTest erases page at 0x84000 and writes some values
	to the page.	*/
void FeeTest(const int *pi3, const char pc2[])
	{
	FeeClr((char*)0x82123,(char*)0x82212);	//Erase 2 pages.
	FeeWr((char*)0x82021,(char*)&pc2[0],5);	//Write non aligned string.
	FeeWr((char*)0x82030,(char*)pi3,4);		//Write uint.
	FeeWr((char*)0x82034,(char*)&pc2[0],1);	//Write single bytes
	FeeWr((char*)0x82035,(char*)&pc2[1],1);	// with various alignment.
	FeeWr((char*)0x82036,(char*)&pc2[2],1);
	FeeWr((char*)0x82037,(char*)&pc2[3],1);
	FeeWr((char*)0x82038,(char*)&pc2[4],1);
	FeeWr((char*)0x82039,(char*)&pc2[1],1);
	}

/* Delay loops uLength times to waste time.	*/
void Delay(unsigned int uLength)
	{
	while(uLength--){}
	}

/*CapTest tests capture functionality  by changing the capture
	source depending on the value of d1. 	*/
void CapTest(double d1)
	{
	if(d1<0.01)	TCap(0,IOFF);
	else if(d1<0.1)	TCap(0,IOFF);
	else if(d1<0.2)	TCap(0,IT1);
	else if(d1<0.3)	TCap(0,IT2);
	else if(d1<0.4)	TCap(0,IT3);
	else if(d1<0.5)	TCap(0,IUART);
	else if(d1<0.6)	TCap(0,XIRQ0);
	else if(d1<0.7)	TCap(0,XIRQ1);
	else if(d1<0.8)	TCap(0,XIRQ2);
	else if(d1<0.9)	TCap(0,XIRQ3);
	else TCap(0,IADC);
	}
	
